diff --git a/src/backend/utils/mb/conversion_procs/cyrillic_and_mic/cyrillic_and_mic.c b/src/backend/utils/mb/conversion_procs/cyrillic/cyrillic.c
similarity index 80%
rename from src/backend/utils/mb/conversion_procs/cyrillic_and_mic/cyrillic_and_mic.c
rename to src/backend/utils/mb/conversion_procs/cyrillic/cyrillic.c
index 8d3c0e94323..16f91c80a75 100644
--- a/src/backend/utils/mb/conversion_procs/cyrillic_and_mic/cyrillic_and_mic.c
+++ b/src/backend/utils/mb/conversion_procs/cyrillic/cyrillic.c
@@ -1,12 +1,12 @@
 /*-------------------------------------------------------------------------
  *
- *	  Cyrillic and MULE_INTERNAL
+ *	  KOI8R, WIN1251, WIN866 and ISO_8859_5
  *
  * Portions Copyright (c) 1996-2026, PostgreSQL Global Development Group
  * Portions Copyright (c) 1994, Regents of the University of California
  *
  * IDENTIFICATION
- *	  src/backend/utils/mb/conversion_procs/cyrillic_and_mic/cyrillic_and_mic.c
+ *	  src/backend/utils/mb/conversion_procs/cyrillic/cyrillic.c
  *
  *-------------------------------------------------------------------------
  */
@@ -16,18 +16,10 @@
 #include "mb/pg_wchar.h"
 
 PG_MODULE_MAGIC_EXT(
-					.name = "cyrillic_and_mic",
+					.name = "cyrillic",
 					.version = PG_VERSION
 );
 
-PG_FUNCTION_INFO_V1(koi8r_to_mic);
-PG_FUNCTION_INFO_V1(mic_to_koi8r);
-PG_FUNCTION_INFO_V1(iso_to_mic);
-PG_FUNCTION_INFO_V1(mic_to_iso);
-PG_FUNCTION_INFO_V1(win1251_to_mic);
-PG_FUNCTION_INFO_V1(mic_to_win1251);
-PG_FUNCTION_INFO_V1(win866_to_mic);
-PG_FUNCTION_INFO_V1(mic_to_win866);
 PG_FUNCTION_INFO_V1(koi8r_to_win1251);
 PG_FUNCTION_INFO_V1(win1251_to_koi8r);
 PG_FUNCTION_INFO_V1(koi8r_to_win866);
@@ -59,7 +51,7 @@ PG_FUNCTION_INFO_V1(win866_to_iso);
  * Cyrillic support
  * currently supported Cyrillic encodings:
  *
- * KOI8-R (this is also the charset for the mule internal code for Cyrillic)
+ * KOI8-R
  * ISO-8859-5
  * Microsoft's CP1251 (windows-1251)
  * Alternativny Variant (MS-DOS CP866)
@@ -306,134 +298,6 @@ static const unsigned char win8662iso[] = {
 };
 
 
-Datum
-koi8r_to_mic(PG_FUNCTION_ARGS)
-{
-	unsigned char *src = (unsigned char *) PG_GETARG_CSTRING(2);
-	unsigned char *dest = (unsigned char *) PG_GETARG_CSTRING(3);
-	int			len = PG_GETARG_INT32(4);
-	bool		noError = PG_GETARG_BOOL(5);
-	int			converted;
-
-	CHECK_ENCODING_CONVERSION_ARGS(PG_KOI8R, PG_MULE_INTERNAL);
-
-	converted = latin2mic(src, dest, len, LC_KOI8_R, PG_KOI8R, noError);
-
-	PG_RETURN_INT32(converted);
-}
-
-Datum
-mic_to_koi8r(PG_FUNCTION_ARGS)
-{
-	unsigned char *src = (unsigned char *) PG_GETARG_CSTRING(2);
-	unsigned char *dest = (unsigned char *) PG_GETARG_CSTRING(3);
-	int			len = PG_GETARG_INT32(4);
-	bool		noError = PG_GETARG_BOOL(5);
-	int			converted;
-
-	CHECK_ENCODING_CONVERSION_ARGS(PG_MULE_INTERNAL, PG_KOI8R);
-
-	converted = mic2latin(src, dest, len, LC_KOI8_R, PG_KOI8R, noError);
-
-	PG_RETURN_INT32(converted);
-}
-
-Datum
-iso_to_mic(PG_FUNCTION_ARGS)
-{
-	unsigned char *src = (unsigned char *) PG_GETARG_CSTRING(2);
-	unsigned char *dest = (unsigned char *) PG_GETARG_CSTRING(3);
-	int			len = PG_GETARG_INT32(4);
-	bool		noError = PG_GETARG_BOOL(5);
-	int			converted;
-
-	CHECK_ENCODING_CONVERSION_ARGS(PG_ISO_8859_5, PG_MULE_INTERNAL);
-
-	converted = latin2mic_with_table(src, dest, len, LC_KOI8_R, PG_ISO_8859_5, iso2koi, noError);
-
-	PG_RETURN_INT32(converted);
-}
-
-Datum
-mic_to_iso(PG_FUNCTION_ARGS)
-{
-	unsigned char *src = (unsigned char *) PG_GETARG_CSTRING(2);
-	unsigned char *dest = (unsigned char *) PG_GETARG_CSTRING(3);
-	int			len = PG_GETARG_INT32(4);
-	bool		noError = PG_GETARG_BOOL(5);
-	int			converted;
-
-	CHECK_ENCODING_CONVERSION_ARGS(PG_MULE_INTERNAL, PG_ISO_8859_5);
-
-	converted = mic2latin_with_table(src, dest, len, LC_KOI8_R, PG_ISO_8859_5, koi2iso, noError);
-
-	PG_RETURN_INT32(converted);
-}
-
-Datum
-win1251_to_mic(PG_FUNCTION_ARGS)
-{
-	unsigned char *src = (unsigned char *) PG_GETARG_CSTRING(2);
-	unsigned char *dest = (unsigned char *) PG_GETARG_CSTRING(3);
-	int			len = PG_GETARG_INT32(4);
-	bool		noError = PG_GETARG_BOOL(5);
-	int			converted;
-
-	CHECK_ENCODING_CONVERSION_ARGS(PG_WIN1251, PG_MULE_INTERNAL);
-
-	converted = latin2mic_with_table(src, dest, len, LC_KOI8_R, PG_WIN1251, win12512koi, noError);
-
-	PG_RETURN_INT32(converted);
-}
-
-Datum
-mic_to_win1251(PG_FUNCTION_ARGS)
-{
-	unsigned char *src = (unsigned char *) PG_GETARG_CSTRING(2);
-	unsigned char *dest = (unsigned char *) PG_GETARG_CSTRING(3);
-	int			len = PG_GETARG_INT32(4);
-	bool		noError = PG_GETARG_BOOL(5);
-	int			converted;
-
-	CHECK_ENCODING_CONVERSION_ARGS(PG_MULE_INTERNAL, PG_WIN1251);
-
-	converted = mic2latin_with_table(src, dest, len, LC_KOI8_R, PG_WIN1251, koi2win1251, noError);
-
-	PG_RETURN_INT32(converted);
-}
-
-Datum
-win866_to_mic(PG_FUNCTION_ARGS)
-{
-	unsigned char *src = (unsigned char *) PG_GETARG_CSTRING(2);
-	unsigned char *dest = (unsigned char *) PG_GETARG_CSTRING(3);
-	int			len = PG_GETARG_INT32(4);
-	bool		noError = PG_GETARG_BOOL(5);
-	int			converted;
-
-	CHECK_ENCODING_CONVERSION_ARGS(PG_WIN866, PG_MULE_INTERNAL);
-
-	converted = latin2mic_with_table(src, dest, len, LC_KOI8_R, PG_WIN866, win8662koi, noError);
-
-	PG_RETURN_INT32(converted);
-}
-
-Datum
-mic_to_win866(PG_FUNCTION_ARGS)
-{
-	unsigned char *src = (unsigned char *) PG_GETARG_CSTRING(2);
-	unsigned char *dest = (unsigned char *) PG_GETARG_CSTRING(3);
-	int			len = PG_GETARG_INT32(4);
-	bool		noError = PG_GETARG_BOOL(5);
-	int			converted;
-
-	CHECK_ENCODING_CONVERSION_ARGS(PG_MULE_INTERNAL, PG_WIN866);
-
-	converted = mic2latin_with_table(src, dest, len, LC_KOI8_R, PG_WIN866, koi2win866, noError);
-
-	PG_RETURN_INT32(converted);
-}
-
 Datum
 koi8r_to_win1251(PG_FUNCTION_ARGS)
 {
diff --git a/src/backend/utils/mb/conversion_procs/euc_jp_and_sjis/euc_jp_and_sjis.c b/src/backend/utils/mb/conversion_procs/euc_jp_and_sjis/euc_jp_and_sjis.c
index 3811a124a49..082c803a8eb 100644
--- a/src/backend/utils/mb/conversion_procs/euc_jp_and_sjis/euc_jp_and_sjis.c
+++ b/src/backend/utils/mb/conversion_procs/euc_jp_and_sjis/euc_jp_and_sjis.c
@@ -1,6 +1,6 @@
 /*-------------------------------------------------------------------------
  *
- *	  EUC_JP, SJIS and MULE_INTERNAL
+ *	  EUC_JP and SJIS
  *
  * Portions Copyright (c) 1996-2026, PostgreSQL Global Development Group
  * Portions Copyright (c) 1994, Regents of the University of California
@@ -34,10 +34,6 @@ PG_MODULE_MAGIC_EXT(
 
 PG_FUNCTION_INFO_V1(euc_jp_to_sjis);
 PG_FUNCTION_INFO_V1(sjis_to_euc_jp);
-PG_FUNCTION_INFO_V1(euc_jp_to_mic);
-PG_FUNCTION_INFO_V1(mic_to_euc_jp);
-PG_FUNCTION_INFO_V1(sjis_to_mic);
-PG_FUNCTION_INFO_V1(mic_to_sjis);
 
 /* ----------
  * conv_proc(
@@ -53,10 +49,6 @@ PG_FUNCTION_INFO_V1(mic_to_sjis);
  * ----------
  */
 
-static int	sjis2mic(const unsigned char *sjis, unsigned char *p, int len, bool noError);
-static int	mic2sjis(const unsigned char *mic, unsigned char *p, int len, bool noError);
-static int	euc_jp2mic(const unsigned char *euc, unsigned char *p, int len, bool noError);
-static int	mic2euc_jp(const unsigned char *mic, unsigned char *p, int len, bool noError);
 static int	euc_jp2sjis(const unsigned char *euc, unsigned char *p, int len, bool noError);
 static int	sjis2euc_jp(const unsigned char *sjis, unsigned char *p, int len, bool noError);
 
@@ -92,444 +84,6 @@ sjis_to_euc_jp(PG_FUNCTION_ARGS)
 	PG_RETURN_INT32(converted);
 }
 
-Datum
-euc_jp_to_mic(PG_FUNCTION_ARGS)
-{
-	unsigned char *src = (unsigned char *) PG_GETARG_CSTRING(2);
-	unsigned char *dest = (unsigned char *) PG_GETARG_CSTRING(3);
-	int			len = PG_GETARG_INT32(4);
-	bool		noError = PG_GETARG_BOOL(5);
-	int			converted;
-
-	CHECK_ENCODING_CONVERSION_ARGS(PG_EUC_JP, PG_MULE_INTERNAL);
-
-	converted = euc_jp2mic(src, dest, len, noError);
-
-	PG_RETURN_INT32(converted);
-}
-
-Datum
-mic_to_euc_jp(PG_FUNCTION_ARGS)
-{
-	unsigned char *src = (unsigned char *) PG_GETARG_CSTRING(2);
-	unsigned char *dest = (unsigned char *) PG_GETARG_CSTRING(3);
-	int			len = PG_GETARG_INT32(4);
-	bool		noError = PG_GETARG_BOOL(5);
-	int			converted;
-
-	CHECK_ENCODING_CONVERSION_ARGS(PG_MULE_INTERNAL, PG_EUC_JP);
-
-	converted = mic2euc_jp(src, dest, len, noError);
-
-	PG_RETURN_INT32(converted);
-}
-
-Datum
-sjis_to_mic(PG_FUNCTION_ARGS)
-{
-	unsigned char *src = (unsigned char *) PG_GETARG_CSTRING(2);
-	unsigned char *dest = (unsigned char *) PG_GETARG_CSTRING(3);
-	int			len = PG_GETARG_INT32(4);
-	bool		noError = PG_GETARG_BOOL(5);
-	int			converted;
-
-	CHECK_ENCODING_CONVERSION_ARGS(PG_SJIS, PG_MULE_INTERNAL);
-
-	converted = sjis2mic(src, dest, len, noError);
-
-	PG_RETURN_INT32(converted);
-}
-
-Datum
-mic_to_sjis(PG_FUNCTION_ARGS)
-{
-	unsigned char *src = (unsigned char *) PG_GETARG_CSTRING(2);
-	unsigned char *dest = (unsigned char *) PG_GETARG_CSTRING(3);
-	int			len = PG_GETARG_INT32(4);
-	bool		noError = PG_GETARG_BOOL(5);
-	int			converted;
-
-	CHECK_ENCODING_CONVERSION_ARGS(PG_MULE_INTERNAL, PG_SJIS);
-
-	converted = mic2sjis(src, dest, len, noError);
-
-	PG_RETURN_INT32(converted);
-}
-
-/*
- * SJIS ---> MIC
- */
-static int
-sjis2mic(const unsigned char *sjis, unsigned char *p, int len, bool noError)
-{
-	const unsigned char *start = sjis;
-	int			c1,
-				c2,
-				i,
-				k,
-				k2;
-
-	while (len > 0)
-	{
-		c1 = *sjis;
-		if (c1 >= 0xa1 && c1 <= 0xdf)
-		{
-			/* JIS X0201 (1 byte kana) */
-			*p++ = LC_JISX0201K;
-			*p++ = c1;
-			sjis++;
-			len--;
-		}
-		else if (IS_HIGHBIT_SET(c1))
-		{
-			/*
-			 * JIS X0208, X0212, user defined extended characters
-			 */
-			if (len < 2 || !ISSJISHEAD(c1) || !ISSJISTAIL(sjis[1]))
-			{
-				if (noError)
-					break;
-				report_invalid_encoding(PG_SJIS, (const char *) sjis, len);
-			}
-			c2 = sjis[1];
-			k = (c1 << 8) + c2;
-			if (k >= 0xed40 && k < 0xf040)
-			{
-				/* NEC selection IBM kanji */
-				for (i = 0;; i++)
-				{
-					k2 = ibmkanji[i].nec;
-					if (k2 == 0xffff)
-						break;
-					if (k2 == k)
-					{
-						k = ibmkanji[i].sjis;
-						c1 = (k >> 8) & 0xff;
-						c2 = k & 0xff;
-					}
-				}
-			}
-
-			if (k < 0xeb3f)
-			{
-				/* JIS X0208 */
-				*p++ = LC_JISX0208;
-				*p++ = ((c1 & 0x3f) << 1) + 0x9f + (c2 > 0x9e);
-				*p++ = c2 + ((c2 > 0x9e) ? 2 : 0x60) + (c2 < 0x80);
-			}
-			else if ((k >= 0xeb40 && k < 0xf040) || (k >= 0xfc4c && k <= 0xfcfc))
-			{
-				/* NEC selection IBM kanji - Other undecided justice */
-				*p++ = LC_JISX0208;
-				*p++ = PGEUCALTCODE >> 8;
-				*p++ = PGEUCALTCODE & 0xff;
-			}
-			else if (k >= 0xf040 && k < 0xf540)
-			{
-				/*
-				 * UDC1 mapping to X0208 85 ku - 94 ku JIS code 0x7521 -
-				 * 0x7e7e EUC 0xf5a1 - 0xfefe
-				 */
-				*p++ = LC_JISX0208;
-				c1 -= 0x6f;
-				*p++ = ((c1 & 0x3f) << 1) + 0xf3 + (c2 > 0x9e);
-				*p++ = c2 + ((c2 > 0x9e) ? 2 : 0x60) + (c2 < 0x80);
-			}
-			else if (k >= 0xf540 && k < 0xfa40)
-			{
-				/*
-				 * UDC2 mapping to X0212 85 ku - 94 ku JIS code 0x7521 -
-				 * 0x7e7e EUC 0x8ff5a1 - 0x8ffefe
-				 */
-				*p++ = LC_JISX0212;
-				c1 -= 0x74;
-				*p++ = ((c1 & 0x3f) << 1) + 0xf3 + (c2 > 0x9e);
-				*p++ = c2 + ((c2 > 0x9e) ? 2 : 0x60) + (c2 < 0x80);
-			}
-			else if (k >= 0xfa40)
-			{
-				/*
-				 * mapping IBM kanji to X0208 and X0212
-				 */
-				for (i = 0;; i++)
-				{
-					k2 = ibmkanji[i].sjis;
-					if (k2 == 0xffff)
-						break;
-					if (k2 == k)
-					{
-						k = ibmkanji[i].euc;
-						if (k >= 0x8f0000)
-						{
-							*p++ = LC_JISX0212;
-							*p++ = 0x80 | ((k & 0xff00) >> 8);
-							*p++ = 0x80 | (k & 0xff);
-						}
-						else
-						{
-							*p++ = LC_JISX0208;
-							*p++ = 0x80 | (k >> 8);
-							*p++ = 0x80 | (k & 0xff);
-						}
-					}
-				}
-			}
-			sjis += 2;
-			len -= 2;
-		}
-		else
-		{						/* should be ASCII */
-			if (c1 == 0)
-			{
-				if (noError)
-					break;
-				report_invalid_encoding(PG_SJIS, (const char *) sjis, len);
-			}
-			*p++ = c1;
-			sjis++;
-			len--;
-		}
-	}
-	*p = '\0';
-
-	return sjis - start;
-}
-
-/*
- * MIC ---> SJIS
- */
-static int
-mic2sjis(const unsigned char *mic, unsigned char *p, int len, bool noError)
-{
-	const unsigned char *start = mic;
-	int			c1,
-				c2,
-				k,
-				l;
-
-	while (len > 0)
-	{
-		c1 = *mic;
-		if (!IS_HIGHBIT_SET(c1))
-		{
-			/* ASCII */
-			if (c1 == 0)
-			{
-				if (noError)
-					break;
-				report_invalid_encoding(PG_MULE_INTERNAL,
-										(const char *) mic, len);
-			}
-			*p++ = c1;
-			mic++;
-			len--;
-			continue;
-		}
-		l = pg_encoding_verifymbchar(PG_MULE_INTERNAL, (const char *) mic, len);
-		if (l < 0)
-		{
-			if (noError)
-				break;
-			report_invalid_encoding(PG_MULE_INTERNAL,
-									(const char *) mic, len);
-		}
-		if (c1 == LC_JISX0201K)
-			*p++ = mic[1];
-		else if (c1 == LC_JISX0208)
-		{
-			c1 = mic[1];
-			c2 = mic[2];
-			k = (c1 << 8) | (c2 & 0xff);
-			if (k >= 0xf5a1)
-			{
-				/* UDC1 */
-				c1 -= 0x54;
-				*p++ = ((c1 - 0xa1) >> 1) + ((c1 < 0xdf) ? 0x81 : 0xc1) + 0x6f;
-			}
-			else
-				*p++ = ((c1 - 0xa1) >> 1) + ((c1 < 0xdf) ? 0x81 : 0xc1);
-			*p++ = c2 - ((c1 & 1) ? ((c2 < 0xe0) ? 0x61 : 0x60) : 2);
-		}
-		else if (c1 == LC_JISX0212)
-		{
-			int			i,
-						k2;
-
-			c1 = mic[1];
-			c2 = mic[2];
-			k = c1 << 8 | c2;
-			if (k >= 0xf5a1)
-			{
-				/* UDC2 */
-				c1 -= 0x54;
-				*p++ = ((c1 - 0xa1) >> 1) + ((c1 < 0xdf) ? 0x81 : 0xc1) + 0x74;
-				*p++ = c2 - ((c1 & 1) ? ((c2 < 0xe0) ? 0x61 : 0x60) : 2);
-			}
-			else
-			{
-				/* IBM kanji */
-				for (i = 0;; i++)
-				{
-					k2 = ibmkanji[i].euc & 0xffff;
-					if (k2 == 0xffff)
-					{
-						*p++ = PGSJISALTCODE >> 8;
-						*p++ = PGSJISALTCODE & 0xff;
-						break;
-					}
-					if (k2 == k)
-					{
-						k = ibmkanji[i].sjis;
-						*p++ = k >> 8;
-						*p++ = k & 0xff;
-						break;
-					}
-				}
-			}
-		}
-		else
-		{
-			if (noError)
-				break;
-			report_untranslatable_char(PG_MULE_INTERNAL, PG_SJIS,
-									   (const char *) mic, len);
-		}
-		mic += l;
-		len -= l;
-	}
-	*p = '\0';
-
-	return mic - start;
-}
-
-/*
- * EUC_JP ---> MIC
- */
-static int
-euc_jp2mic(const unsigned char *euc, unsigned char *p, int len, bool noError)
-{
-	const unsigned char *start = euc;
-	int			c1;
-	int			l;
-
-	while (len > 0)
-	{
-		c1 = *euc;
-		if (!IS_HIGHBIT_SET(c1))
-		{
-			/* ASCII */
-			if (c1 == 0)
-			{
-				if (noError)
-					break;
-				report_invalid_encoding(PG_EUC_JP,
-										(const char *) euc, len);
-			}
-			*p++ = c1;
-			euc++;
-			len--;
-			continue;
-		}
-		l = pg_encoding_verifymbchar(PG_EUC_JP, (const char *) euc, len);
-		if (l < 0)
-		{
-			if (noError)
-				break;
-			report_invalid_encoding(PG_EUC_JP,
-									(const char *) euc, len);
-		}
-		if (c1 == SS2)
-		{						/* 1 byte kana? */
-			*p++ = LC_JISX0201K;
-			*p++ = euc[1];
-		}
-		else if (c1 == SS3)
-		{						/* JIS X0212 kanji? */
-			*p++ = LC_JISX0212;
-			*p++ = euc[1];
-			*p++ = euc[2];
-		}
-		else
-		{						/* kanji? */
-			*p++ = LC_JISX0208;
-			*p++ = c1;
-			*p++ = euc[1];
-		}
-		euc += l;
-		len -= l;
-	}
-	*p = '\0';
-
-	return euc - start;
-}
-
-/*
- * MIC ---> EUC_JP
- */
-static int
-mic2euc_jp(const unsigned char *mic, unsigned char *p, int len, bool noError)
-{
-	const unsigned char *start = mic;
-	int			c1;
-	int			l;
-
-	while (len > 0)
-	{
-		c1 = *mic;
-		if (!IS_HIGHBIT_SET(c1))
-		{
-			/* ASCII */
-			if (c1 == 0)
-			{
-				if (noError)
-					break;
-				report_invalid_encoding(PG_MULE_INTERNAL,
-										(const char *) mic, len);
-			}
-			*p++ = c1;
-			mic++;
-			len--;
-			continue;
-		}
-		l = pg_encoding_verifymbchar(PG_MULE_INTERNAL, (const char *) mic, len);
-		if (l < 0)
-		{
-			if (noError)
-				break;
-			report_invalid_encoding(PG_MULE_INTERNAL,
-									(const char *) mic, len);
-		}
-		if (c1 == LC_JISX0201K)
-		{
-			*p++ = SS2;
-			*p++ = mic[1];
-		}
-		else if (c1 == LC_JISX0212)
-		{
-			*p++ = SS3;
-			*p++ = mic[1];
-			*p++ = mic[2];
-		}
-		else if (c1 == LC_JISX0208)
-		{
-			*p++ = mic[1];
-			*p++ = mic[2];
-		}
-		else
-		{
-			if (noError)
-				break;
-			report_untranslatable_char(PG_MULE_INTERNAL, PG_EUC_JP,
-									   (const char *) mic, len);
-		}
-		mic += l;
-		len -= l;
-	}
-	*p = '\0';
-
-	return mic - start;
-}
-
 /*
  * EUC_JP -> SJIS
  */
diff --git a/src/backend/utils/mb/conversion_procs/euc_tw_and_big5/big5.c b/src/backend/utils/mb/conversion_procs/euc_tw_and_big5/big5.c
index 68f76aa8cb8..c84c7ed0e39 100644
--- a/src/backend/utils/mb/conversion_procs/euc_tw_and_big5/big5.c
+++ b/src/backend/utils/mb/conversion_procs/euc_tw_and_big5/big5.c
@@ -1,6 +1,5 @@
 /*
- * conversion between BIG5 and Mule Internal Code(CNS 116643-1992
- * plane 1 and plane 2).
+ * BIG5 support functions (CNS 116643-1992 * plane 1 and plane 2).
  * This program is partially copied from lv(Multilingual file viewer)
  * and slightly modified. lv is written and copyrighted by NARITA Tomio
  * (nrt@web.ad.jp).
diff --git a/src/backend/utils/mb/conversion_procs/euc_tw_and_big5/euc_tw_and_big5.c b/src/backend/utils/mb/conversion_procs/euc_tw_and_big5/euc_tw_and_big5.c
index 8db3c796f1a..4dac49b3b90 100644
--- a/src/backend/utils/mb/conversion_procs/euc_tw_and_big5/euc_tw_and_big5.c
+++ b/src/backend/utils/mb/conversion_procs/euc_tw_and_big5/euc_tw_and_big5.c
@@ -1,6 +1,6 @@
 /*-------------------------------------------------------------------------
  *
- *	  EUC_TW, BIG5 and MULE_INTERNAL
+ *	  EUC_TW and BIG5
  *
  * Portions Copyright (c) 1996-2026, PostgreSQL Global Development Group
  * Portions Copyright (c) 1994, Regents of the University of California
@@ -22,10 +22,6 @@ PG_MODULE_MAGIC_EXT(
 
 PG_FUNCTION_INFO_V1(euc_tw_to_big5);
 PG_FUNCTION_INFO_V1(big5_to_euc_tw);
-PG_FUNCTION_INFO_V1(euc_tw_to_mic);
-PG_FUNCTION_INFO_V1(mic_to_euc_tw);
-PG_FUNCTION_INFO_V1(big5_to_mic);
-PG_FUNCTION_INFO_V1(mic_to_big5);
 
 /* ----------
  * conv_proc(
@@ -43,10 +39,6 @@ PG_FUNCTION_INFO_V1(mic_to_big5);
 
 static int	euc_tw2big5(const unsigned char *euc, unsigned char *p, int len, bool noError);
 static int	big52euc_tw(const unsigned char *big5, unsigned char *p, int len, bool noError);
-static int	big52mic(const unsigned char *big5, unsigned char *p, int len, bool noError);
-static int	mic2big5(const unsigned char *mic, unsigned char *p, int len, bool noError);
-static int	euc_tw2mic(const unsigned char *euc, unsigned char *p, int len, bool noError);
-static int	mic2euc_tw(const unsigned char *mic, unsigned char *p, int len, bool noError);
 
 Datum
 euc_tw_to_big5(PG_FUNCTION_ARGS)
@@ -80,74 +72,6 @@ big5_to_euc_tw(PG_FUNCTION_ARGS)
 	PG_RETURN_INT32(converted);
 }
 
-Datum
-euc_tw_to_mic(PG_FUNCTION_ARGS)
-{
-	unsigned char *src = (unsigned char *) PG_GETARG_CSTRING(2);
-	unsigned char *dest = (unsigned char *) PG_GETARG_CSTRING(3);
-	int			len = PG_GETARG_INT32(4);
-	bool		noError = PG_GETARG_BOOL(5);
-	int			converted;
-
-	CHECK_ENCODING_CONVERSION_ARGS(PG_EUC_TW, PG_MULE_INTERNAL);
-
-	converted = euc_tw2mic(src, dest, len, noError);
-
-	PG_RETURN_INT32(converted);
-}
-
-Datum
-mic_to_euc_tw(PG_FUNCTION_ARGS)
-{
-	unsigned char *src = (unsigned char *) PG_GETARG_CSTRING(2);
-	unsigned char *dest = (unsigned char *) PG_GETARG_CSTRING(3);
-	int			len = PG_GETARG_INT32(4);
-	bool		noError = PG_GETARG_BOOL(5);
-	int			converted;
-
-	CHECK_ENCODING_CONVERSION_ARGS(PG_MULE_INTERNAL, PG_EUC_TW);
-
-	converted = mic2euc_tw(src, dest, len, noError);
-
-	PG_RETURN_INT32(converted);
-}
-
-Datum
-big5_to_mic(PG_FUNCTION_ARGS)
-{
-	unsigned char *src = (unsigned char *) PG_GETARG_CSTRING(2);
-	unsigned char *dest = (unsigned char *) PG_GETARG_CSTRING(3);
-	int			len = PG_GETARG_INT32(4);
-	bool		noError = PG_GETARG_BOOL(5);
-	int			converted;
-
-	CHECK_ENCODING_CONVERSION_ARGS(PG_BIG5, PG_MULE_INTERNAL);
-
-	converted = big52mic(src, dest, len, noError);
-
-	PG_RETURN_INT32(converted);
-}
-
-Datum
-mic_to_big5(PG_FUNCTION_ARGS)
-{
-	unsigned char *src = (unsigned char *) PG_GETARG_CSTRING(2);
-	unsigned char *dest = (unsigned char *) PG_GETARG_CSTRING(3);
-	int			len = PG_GETARG_INT32(4);
-	bool		noError = PG_GETARG_BOOL(5);
-	int			converted;
-
-	CHECK_ENCODING_CONVERSION_ARGS(PG_MULE_INTERNAL, PG_BIG5);
-
-	converted = mic2big5(src, dest, len, noError);
-
-	PG_RETURN_INT32(converted);
-}
-
-
-/*
- * EUC_TW ---> Big5
- */
 static int
 euc_tw2big5(const unsigned char *euc, unsigned char *p, int len, bool noError)
 {
@@ -303,281 +227,3 @@ big52euc_tw(const unsigned char *big5, unsigned char *p, int len, bool noError)
 
 	return big5 - start;
 }
-
-/*
- * EUC_TW ---> MIC
- */
-static int
-euc_tw2mic(const unsigned char *euc, unsigned char *p, int len, bool noError)
-{
-	const unsigned char *start = euc;
-	int			c1;
-	int			l;
-
-	while (len > 0)
-	{
-		c1 = *euc;
-		if (IS_HIGHBIT_SET(c1))
-		{
-			l = pg_encoding_verifymbchar(PG_EUC_TW, (const char *) euc, len);
-			if (l < 0)
-			{
-				if (noError)
-					break;
-				report_invalid_encoding(PG_EUC_TW,
-										(const char *) euc, len);
-			}
-			if (c1 == SS2)
-			{
-				c1 = euc[1];	/* plane No. */
-				if (c1 == 0xa1)
-					*p++ = LC_CNS11643_1;
-				else if (c1 == 0xa2)
-					*p++ = LC_CNS11643_2;
-				else
-				{
-					/* other planes are MULE private charsets */
-					*p++ = LCPRV2_B;
-					*p++ = c1 - 0xa3 + LC_CNS11643_3;
-				}
-				*p++ = euc[2];
-				*p++ = euc[3];
-			}
-			else
-			{					/* CNS11643-1 */
-				*p++ = LC_CNS11643_1;
-				*p++ = c1;
-				*p++ = euc[1];
-			}
-			euc += l;
-			len -= l;
-		}
-		else
-		{						/* should be ASCII */
-			if (c1 == 0)
-			{
-				if (noError)
-					break;
-				report_invalid_encoding(PG_EUC_TW,
-										(const char *) euc, len);
-			}
-			*p++ = c1;
-			euc++;
-			len--;
-		}
-	}
-	*p = '\0';
-
-	return euc - start;
-}
-
-/*
- * MIC ---> EUC_TW
- */
-static int
-mic2euc_tw(const unsigned char *mic, unsigned char *p, int len, bool noError)
-{
-	const unsigned char *start = mic;
-	int			c1;
-	int			l;
-
-	while (len > 0)
-	{
-		c1 = *mic;
-		if (!IS_HIGHBIT_SET(c1))
-		{
-			/* ASCII */
-			if (c1 == 0)
-			{
-				if (noError)
-					break;
-				report_invalid_encoding(PG_MULE_INTERNAL,
-										(const char *) mic, len);
-			}
-			*p++ = c1;
-			mic++;
-			len--;
-			continue;
-		}
-		l = pg_encoding_verifymbchar(PG_MULE_INTERNAL, (const char *) mic, len);
-		if (l < 0)
-		{
-			if (noError)
-				break;
-			report_invalid_encoding(PG_MULE_INTERNAL,
-									(const char *) mic, len);
-		}
-		if (c1 == LC_CNS11643_1)
-		{
-			*p++ = mic[1];
-			*p++ = mic[2];
-		}
-		else if (c1 == LC_CNS11643_2)
-		{
-			*p++ = SS2;
-			*p++ = 0xa2;
-			*p++ = mic[1];
-			*p++ = mic[2];
-		}
-		else if (c1 == LCPRV2_B &&
-				 mic[1] >= LC_CNS11643_3 && mic[1] <= LC_CNS11643_7)
-		{
-			*p++ = SS2;
-			*p++ = mic[1] - LC_CNS11643_3 + 0xa3;
-			*p++ = mic[2];
-			*p++ = mic[3];
-		}
-		else
-		{
-			if (noError)
-				break;
-			report_untranslatable_char(PG_MULE_INTERNAL, PG_EUC_TW,
-									   (const char *) mic, len);
-		}
-		mic += l;
-		len -= l;
-	}
-	*p = '\0';
-
-	return mic - start;
-}
-
-/*
- * Big5 ---> MIC
- */
-static int
-big52mic(const unsigned char *big5, unsigned char *p, int len, bool noError)
-{
-	const unsigned char *start = big5;
-	unsigned short c1;
-	unsigned short big5buf,
-				cnsBuf;
-	unsigned char lc;
-	int			l;
-
-	while (len > 0)
-	{
-		c1 = *big5;
-		if (!IS_HIGHBIT_SET(c1))
-		{
-			/* ASCII */
-			if (c1 == 0)
-			{
-				if (noError)
-					break;
-				report_invalid_encoding(PG_BIG5,
-										(const char *) big5, len);
-			}
-			*p++ = c1;
-			big5++;
-			len--;
-			continue;
-		}
-		l = pg_encoding_verifymbchar(PG_BIG5, (const char *) big5, len);
-		if (l < 0)
-		{
-			if (noError)
-				break;
-			report_invalid_encoding(PG_BIG5,
-									(const char *) big5, len);
-		}
-		big5buf = (c1 << 8) | big5[1];
-		cnsBuf = BIG5toCNS(big5buf, &lc);
-		if (lc != 0)
-		{
-			/* Planes 3 and 4 are MULE private charsets */
-			if (lc == LC_CNS11643_3 || lc == LC_CNS11643_4)
-				*p++ = LCPRV2_B;
-			*p++ = lc;			/* Plane No. */
-			*p++ = (cnsBuf >> 8) & 0x00ff;
-			*p++ = cnsBuf & 0x00ff;
-		}
-		else
-		{
-			if (noError)
-				break;
-			report_untranslatable_char(PG_BIG5, PG_MULE_INTERNAL,
-									   (const char *) big5, len);
-		}
-		big5 += l;
-		len -= l;
-	}
-	*p = '\0';
-
-	return big5 - start;
-}
-
-/*
- * MIC ---> Big5
- */
-static int
-mic2big5(const unsigned char *mic, unsigned char *p, int len, bool noError)
-{
-	const unsigned char *start = mic;
-	unsigned short c1;
-	unsigned short big5buf,
-				cnsBuf;
-	int			l;
-
-	while (len > 0)
-	{
-		c1 = *mic;
-		if (!IS_HIGHBIT_SET(c1))
-		{
-			/* ASCII */
-			if (c1 == 0)
-			{
-				if (noError)
-					break;
-				report_invalid_encoding(PG_MULE_INTERNAL,
-										(const char *) mic, len);
-			}
-			*p++ = c1;
-			mic++;
-			len--;
-			continue;
-		}
-		l = pg_encoding_verifymbchar(PG_MULE_INTERNAL, (const char *) mic, len);
-		if (l < 0)
-		{
-			if (noError)
-				break;
-			report_invalid_encoding(PG_MULE_INTERNAL,
-									(const char *) mic, len);
-		}
-		if (c1 == LC_CNS11643_1 || c1 == LC_CNS11643_2 || c1 == LCPRV2_B)
-		{
-			if (c1 == LCPRV2_B)
-			{
-				c1 = mic[1];	/* get plane no. */
-				cnsBuf = (mic[2] << 8) | mic[3];
-			}
-			else
-			{
-				cnsBuf = (mic[1] << 8) | mic[2];
-			}
-			big5buf = CNStoBIG5(cnsBuf, c1);
-			if (big5buf == 0)
-			{
-				if (noError)
-					break;
-				report_untranslatable_char(PG_MULE_INTERNAL, PG_BIG5,
-										   (const char *) mic, len);
-			}
-			*p++ = (big5buf >> 8) & 0x00ff;
-			*p++ = big5buf & 0x00ff;
-		}
-		else
-		{
-			if (noError)
-				break;
-			report_untranslatable_char(PG_MULE_INTERNAL, PG_BIG5,
-									   (const char *) mic, len);
-		}
-		mic += l;
-		len -= l;
-	}
-	*p = '\0';
-
-	return mic - start;
-}
diff --git a/src/backend/utils/mb/conversion_procs/latin2_and_win1250/latin2_and_win1250.c b/src/backend/utils/mb/conversion_procs/latin2_and_win1250/latin2_and_win1250.c
index aa46641d56d..29201c94434 100644
--- a/src/backend/utils/mb/conversion_procs/latin2_and_win1250/latin2_and_win1250.c
+++ b/src/backend/utils/mb/conversion_procs/latin2_and_win1250/latin2_and_win1250.c
@@ -20,10 +20,6 @@ PG_MODULE_MAGIC_EXT(
 					.version = PG_VERSION
 );
 
-PG_FUNCTION_INFO_V1(latin2_to_mic);
-PG_FUNCTION_INFO_V1(mic_to_latin2);
-PG_FUNCTION_INFO_V1(win1250_to_mic);
-PG_FUNCTION_INFO_V1(mic_to_win1250);
 PG_FUNCTION_INFO_V1(latin2_to_win1250);
 PG_FUNCTION_INFO_V1(win1250_to_latin2);
 
@@ -82,72 +78,6 @@ static const unsigned char iso88592_2_win1250[] = {
 };
 
 
-Datum
-latin2_to_mic(PG_FUNCTION_ARGS)
-{
-	unsigned char *src = (unsigned char *) PG_GETARG_CSTRING(2);
-	unsigned char *dest = (unsigned char *) PG_GETARG_CSTRING(3);
-	int			len = PG_GETARG_INT32(4);
-	bool		noError = PG_GETARG_BOOL(5);
-	int			converted;
-
-	CHECK_ENCODING_CONVERSION_ARGS(PG_LATIN2, PG_MULE_INTERNAL);
-
-	converted = latin2mic(src, dest, len, LC_ISO8859_2, PG_LATIN2, noError);
-
-	PG_RETURN_INT32(converted);
-}
-
-Datum
-mic_to_latin2(PG_FUNCTION_ARGS)
-{
-	unsigned char *src = (unsigned char *) PG_GETARG_CSTRING(2);
-	unsigned char *dest = (unsigned char *) PG_GETARG_CSTRING(3);
-	int			len = PG_GETARG_INT32(4);
-	bool		noError = PG_GETARG_BOOL(5);
-	int			converted;
-
-	CHECK_ENCODING_CONVERSION_ARGS(PG_MULE_INTERNAL, PG_LATIN2);
-
-	converted = mic2latin(src, dest, len, LC_ISO8859_2, PG_LATIN2, noError);
-
-	PG_RETURN_INT32(converted);
-}
-
-Datum
-win1250_to_mic(PG_FUNCTION_ARGS)
-{
-	unsigned char *src = (unsigned char *) PG_GETARG_CSTRING(2);
-	unsigned char *dest = (unsigned char *) PG_GETARG_CSTRING(3);
-	int			len = PG_GETARG_INT32(4);
-	bool		noError = PG_GETARG_BOOL(5);
-	int			converted;
-
-	CHECK_ENCODING_CONVERSION_ARGS(PG_WIN1250, PG_MULE_INTERNAL);
-
-	converted = latin2mic_with_table(src, dest, len, LC_ISO8859_2, PG_WIN1250,
-									 win1250_2_iso88592, noError);
-
-	PG_RETURN_INT32(converted);
-}
-
-Datum
-mic_to_win1250(PG_FUNCTION_ARGS)
-{
-	unsigned char *src = (unsigned char *) PG_GETARG_CSTRING(2);
-	unsigned char *dest = (unsigned char *) PG_GETARG_CSTRING(3);
-	int			len = PG_GETARG_INT32(4);
-	bool		noError = PG_GETARG_BOOL(5);
-	int			converted;
-
-	CHECK_ENCODING_CONVERSION_ARGS(PG_MULE_INTERNAL, PG_WIN1250);
-
-	converted = mic2latin_with_table(src, dest, len, LC_ISO8859_2, PG_WIN1250,
-									 iso88592_2_win1250, noError);
-
-	PG_RETURN_INT32(converted);
-}
-
 Datum
 latin2_to_win1250(PG_FUNCTION_ARGS)
 {
diff --git a/src/backend/utils/mb/conversion_procs/meson.build b/src/backend/utils/mb/conversion_procs/meson.build
index 404afdde360..6c6fd30a01f 100644
--- a/src/backend/utils/mb/conversion_procs/meson.build
+++ b/src/backend/utils/mb/conversion_procs/meson.build
@@ -1,17 +1,14 @@
 # Copyright (c) 2022-2026, PostgreSQL Global Development Group
 
 encodings = {
-  'cyrillic_and_mic': ['cyrillic_and_mic/cyrillic_and_mic.c'],
+  'cyrillic': ['cyrillic/cyrillic.c'],
   'euc2004_sjis2004': ['euc2004_sjis2004/euc2004_sjis2004.c'],
-  'euc_cn_and_mic': ['euc_cn_and_mic/euc_cn_and_mic.c'],
   'euc_jp_and_sjis': ['euc_jp_and_sjis/euc_jp_and_sjis.c'],
-  'euc_kr_and_mic': ['euc_kr_and_mic/euc_kr_and_mic.c'],
   'euc_tw_and_big5': [
     'euc_tw_and_big5/euc_tw_and_big5.c',
     'euc_tw_and_big5/big5.c',
   ],
   'latin2_and_win1250': ['latin2_and_win1250/latin2_and_win1250.c'],
-  'latin_and_mic': ['latin_and_mic/latin_and_mic.c'],
   'utf8_and_big5': ['utf8_and_big5/utf8_and_big5.c'],
   'utf8_and_cyrillic': ['utf8_and_cyrillic/utf8_and_cyrillic.c'],
   'utf8_and_euc2004': ['utf8_and_euc2004/utf8_and_euc2004.c'],
diff --git a/src/backend/utils/mb/mbutils.c b/src/backend/utils/mb/mbutils.c
index a5a734839af..6009ee2b988 100644
--- a/src/backend/utils/mb/mbutils.c
+++ b/src/backend/utils/mb/mbutils.c
@@ -1306,8 +1306,7 @@ SetMessageEncoding(int encoding)
 #ifdef ENABLE_NLS
 /*
  * Make one bind_textdomain_codeset() call, translating a pg_enc to a gettext
- * codeset.  Fails for MULE_INTERNAL, an encoding unknown to gettext; can also
- * fail for gettext-internal causes like out-of-memory.
+ * codeset.  Can fail for gettext-internal causes like out-of-memory.
  */
 static bool
 raw_pg_bind_textdomain_codeset(const char *domainname, int encoding)
@@ -1427,8 +1426,7 @@ PG_encoding_to_char(PG_FUNCTION_ARGS)
 /*
  * gettext() returns messages in this encoding.  This often matches the
  * database encoding, but it differs for SQL_ASCII databases, for processes
- * not attached to a database, and under a database encoding lacking iconv
- * support (MULE_INTERNAL).
+ * not attached to a database.
  */
 int
 GetMessageEncoding(void)
diff --git a/src/common/encnames.c b/src/common/encnames.c
index f833ae8edfe..9085dbecce1 100644
--- a/src/common/encnames.c
+++ b/src/common/encnames.c
@@ -164,9 +164,6 @@ static const pg_encname pg_encname_tbl[] =
 	{
 		"mskanji", PG_SJIS
 	},							/* alias for Shift_JIS */
-	{
-		"muleinternal", PG_MULE_INTERNAL
-	},
 	{
 		"shiftjis", PG_SJIS
 	},							/* Shift_JIS; JIS X 0202-1991 */
@@ -314,7 +311,6 @@ const pg_enc2name pg_enc2name_tbl[] =
 	[PG_EUC_TW] = DEF_ENC2NAME(EUC_TW, 0),
 	[PG_EUC_JIS_2004] = DEF_ENC2NAME(EUC_JIS_2004, 20932),
 	[PG_UTF8] = DEF_ENC2NAME(UTF8, 65001),
-	[PG_MULE_INTERNAL] = DEF_ENC2NAME(MULE_INTERNAL, 0),
 	[PG_LATIN1] = DEF_ENC2NAME(LATIN1, 28591),
 	[PG_LATIN2] = DEF_ENC2NAME(LATIN2, 28592),
 	[PG_LATIN3] = DEF_ENC2NAME(LATIN3, 28593),
@@ -353,15 +349,12 @@ const pg_enc2name pg_enc2name_tbl[] =
 
 /* ----------
  * These are encoding names for gettext.
- *
- * This covers all encodings except MULE_INTERNAL, which is alien to gettext.
  * ----------
  */
 const char *pg_enc2gettext_tbl[] =
 {
 	[PG_SQL_ASCII] = "US-ASCII",
 	[PG_UTF8] = "UTF-8",
-	[PG_MULE_INTERNAL] = NULL,
 	[PG_LATIN1] = "LATIN1",
 	[PG_LATIN2] = "LATIN2",
 	[PG_LATIN3] = "LATIN3",
@@ -420,7 +413,6 @@ static const char *const pg_enc2icu_tbl[] =
 	[PG_EUC_TW] = "EUC-TW",
 	[PG_EUC_JIS_2004] = NULL,
 	[PG_UTF8] = "UTF-8",
-	[PG_MULE_INTERNAL] = NULL,
 	[PG_LATIN1] = "ISO-8859-1",
 	[PG_LATIN2] = "ISO-8859-2",
 	[PG_LATIN3] = "ISO-8859-3",
